#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire300seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire300seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven3004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven3004xi = {
                1:'-102x-266y93z',
                2:'-103x-236y152z',
                3:'-107x-111y256z',
                4:'-111x-104y258z',
                5:'-114x-96y259z',
                6:'-115x-229y154z',
                7:'-115x-259y96z',
                8:'-117x-88y261z',
                9:'-119x-81y262z',
                10:'-121x-73y264z',
                11:'-122x-65y265z',
                12:'-123x-58y266z',
                13:'-124x-50y268z',
                14:'-126x-221y157z',
                15:'-128x-252y99z',
                16:'-12x-153y257z',
                17:'-12x-268y133z',
                18:'-136x-213y159z',
                19:'-137x-159y340z',
                20:'-141x-244y102z',
                21:'-147x-204y162z',
                22:'-153x-235y104z',
                23:'-153x-257y0z',
                24:'-156x-195y164z',
                25:'-15x-289y76z',
                26:'-164x-226y107z',
                27:'-165x-185y167z',
                28:'-166x-249y3z',
                29:'-173x-175y169z',
                30:'-175x-216y110z',
                31:'-179x-240y6z',
                32:'-181x-165y172z',
                33:'-185x-206y113z',
                34:'-188x-154y174z',
                35:'-191x-230y9z',
                36:'-194x-143y177z',
                37:'-195x-195y116z',
                38:'-19x-149y259z',
                39:'-200x-132y179z',
                40:'-203x-220y12z',
                41:'-204x-184y118z',
                42:'-205x-120y182z',
                43:'-210x-108y184z',
                44:'-213x-172y121z',
                45:'-213x-96y186z',
                46:'-214x-209y15z',
                47:'-216x-84y189z',
                48:'-219x-72y191z',
                49:'-220x-160y124z',
                50:'-220x-60y193z',
                51:'-221x-48y196z',
                52:'-225x-197y18z',
                53:'-227x-148y127z',
                54:'-234x-135y129z',
                55:'-234x-185y21z',
                56:'-239x-122y132z',
                57:'-244x-108y135z',
                58:'-244x-172y24z',
                59:'-248x-95y137z',
                60:'-252x-159y27z',
                61:'-252x-81y140z',
                62:'-254x-68y143z',
                63:'-256x-54y145z',
                64:'-257x-27y150z',
                65:'-257x-40y148z',
                66:'-260x-145y30z',
                67:'-267x-131y33z',
                68:'-26x-265y136z',
                69:'-273x-117y36z',
                70:'-278x-102y39z',
                71:'-27x-146y260z',
                72:'-283x-88y42z',
                73:'-287x-73y45z',
                74:'-2x-2y299z',
                75:'-2x-42y296z',
                76:'-30x-287y79z',
                77:'-34x-141y262z',
                78:'-40x-137y263z',
                79:'-40x-262y139z',
                80:'-45x-284y82z',
                81:'-47x-132y264z',
                82:'-4x-156y256z',
                83:'-4x-39y297z',
                84:'-4x-5y299z',
                85:'-53x-127y266z',
                86:'-53x-258y141z',
                87:'-58x-122y267z',
                88:'-59x-281y84z',
                89:'-63x-116y269z',
                90:'-66x-254y144z',
                91:'-68x-110y270z',
                92:'-6x-36y297z',
                93:'-6x-8y299z',
                94:'-72x-104y271z',
                95:'-74x-277y87z',
                96:'-75x-98y272z',
                97:'-79x-249y147z',
                98:'-79x-92y274z',
                99:'-7x-10y299z',
                100:'-7x-33y298z',
                101:'-82x-86y275z',
                102:'-83x-15y287z',
                103:'-84x-80y276z',
                104:'-85x-20y286z',
                105:'-86x-73y277z',
                106:'-87x-25y285z',
                107:'-88x-271y90z',
                108:'-88x-31y284z',
                109:'-88x-67y278z',
                110:'-89x-36y283z',
                111:'-89x-42y282z',
                112:'-89x-54y280z',
                113:'-89x-61y279z',
                114:'-8x-13y299z',
                115:'-8x-16y299z',
                116:'-8x-29y298z',
                117:'-90x-48y281z',
                118:'-91x-243y149z',
                119:'-9x-20y299z',
                120:'-9x-23y298z',
                121:'-9x-26y298z',
                122:'0x-290y73z',
                123:'0x-45y296z',
                124:'0x0y299z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire300seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire300seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE300SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE300SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE300SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE300SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE300SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven3004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE300SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE300SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE300SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven3004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven3004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE300SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE300SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE300SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire300seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       